//+------------------------------------------------------------------+
//|                                                 LaGuerre RSI.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1  DimGray
#property indicator_color2  DeepSkyBlue
#property indicator_color3  DeepSkyBlue
#property indicator_color4  DeepSkyBlue
#property indicator_color5  Red
#property indicator_color6  Red
#property indicator_color7  Red
#property indicator_style1  STYLE_DOT

//
//
//
//
//

extern bool ignoreSunday = true;

//
//
//
//
//

double PBuffer[];
double R1Buffer[];
double R2Buffer[];
double R3Buffer[];
double S1Buffer[];
double S2Buffer[];
double S3Buffer[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   SetIndexBuffer(0, PBuffer);  SetIndexLabel(0,"Pivot");
   SetIndexBuffer(1, R1Buffer); SetIndexLabel(1,"R1");
   SetIndexBuffer(2, R2Buffer); SetIndexLabel(2,"R2");
   SetIndexBuffer(3, R3Buffer); SetIndexLabel(3,"R3");
   SetIndexBuffer(4, S1Buffer); SetIndexLabel(4,"S1");
   SetIndexBuffer(5, S2Buffer); SetIndexLabel(5,"S2");
   SetIndexBuffer(6, S3Buffer); SetIndexLabel(6,"S3");
   return(0);
}

int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int    counted_bars=IndicatorCounted();
   int    i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars - counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(i = limit; i >= 0 ; i--)
   {
      int dayBar = iBarShift(NULL,PERIOD_D1,Time[i])+1;
      if (ignoreSunday)
      if (TimeDayOfWeek(iTime(NULL,PERIOD_D1,dayBar))==0) dayBar++;
      
         //
         //
         //
         //
         //
         
            double open  = iOpen(NULL,PERIOD_D1,dayBar);
            double high  = iHigh(NULL,PERIOD_D1,dayBar);
            double low   = iLow(NULL,PERIOD_D1,dayBar);
            double close = iClose(NULL,PERIOD_D1,dayBar);
            double range = high-low;
         
               if (close >  open) PBuffer[i] = (2*high+low+close)/4.0;
               if (close <  open) PBuffer[i] = (2*low+high+close)/4.0;
               if (close == open) PBuffer[i] = (2*close+high+low)/4.0;

         //
         //
         //
         //
         //
           
         R1Buffer[i] = 2.0*PBuffer[i]-low;
         R2Buffer[i] = PBuffer[i]+range;
         R3Buffer[i] = R1Buffer[i]+range;
         
         S1Buffer[i] = 2.0*PBuffer[i]-high;
         S2Buffer[i] = PBuffer[i]-range;
         S3Buffer[i] = S1Buffer[i]-range;
   }            
   return(0);
}